SystemOrganization addCategory: 'OrbeonBizagiReader2_Tests'!

TestCase subclass: #XPDLReader2Test2
	instanceVariableNames: 'reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2_Tests'!

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:39'!
getFixIssuePool

	^(reader getPackageNamed: 'fix-issue') getPoolNamed: 'fix-issue' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:40'!
getFixIssueWorkflow

	^(reader getPackageNamed: 'fix-issue') getWorkflowNamed: 'fix-issue' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:40'!
getReportToArchitectPool

	^(reader getPackageNamed: 'report-to-architect') getPoolNamed: 'architect-process' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:40'!
getReportToArchitectWorkflow

	^(reader getPackageNamed: 'report-to-architect') getWorkflowNamed: 'architect-process' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:38'!
getTestCasePool

	^(reader getPackageNamed: 'test-case') getPoolNamed: 'test-case-process' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 14:39'!
getTestCaseWorkflow

	^(reader getPackageNamed: 'test-case') getWorkflowNamed: 'test-case-process' ifNone: [self assert: false]! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:11'!
setUp

	reader := (XPDLReader2 for: 'TestCase' withString: XPDLProcessTemplate xpdlExample_ProcessTestCase)
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessFixIssue) namedAs: 'FixIssue';
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessReportToArchitect) namedAs: 'ReportToArchitect';
				connectProcesses;
				yourself! !

!XPDLReader2Test2 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 17:20'!
test1

	self assert: false! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 11/27/2015 16:26'!
testActivitiesNames
	| taskNames |

	taskNames := #('test-case' 'execute-test' 'test-ok' 'analyze-issue-report').

	self assert: (self getTestCaseWorkflow getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getTestCaseWorkflow getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 11/27/2015 15:05'!
testActivitiesNames2
	| taskNames |

	taskNames := #('analyze-issue' 'report-fixes' 'internal-test').

	self assert: (self getFixIssueWorkflow getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getFixIssueWorkflow getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 activities' stamp: 'BrunoBB 11/27/2015 16:29'!
testActivitiesNames3
	| taskNames |

	taskNames := #('analyze-developer-report' 'report-workaround' 'report-solution').

	self assert: (self getReportToArchitectWorkflow getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getReportToArchitectWorkflow getTaskNodes size = taskNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 11/27/2015 16:26'!
testGatewaysNames
	| gatewaysNames |

	gatewaysNames := #('is-issue' 'accept-issue').

	self assert: (self getTestCaseWorkflow getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getTestCaseWorkflow getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 11/27/2015 16:25'!
testGatewaysNames2
	| gatewaysNames |

	gatewaysNames := #('can fix').

	self assert: (self getFixIssueWorkflow getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getFixIssueWorkflow getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 activities' stamp: 'BrunoBB 11/27/2015 16:29'!
testGatewaysNames3
	| gatewaysNames |

	gatewaysNames := #('has-solution').

	self assert: (self getReportToArchitectWorkflow getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getReportToArchitectWorkflow getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 11/27/2015 16:27'!
testInTransitions
	| process transition task1 gateway |

	process := self getTestCaseWorkflow.

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'test-ok' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-finished' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 11/27/2015 16:28'!
testInTransitions2
	| process transition task1 gateway |

	process := self getFixIssueWorkflow.

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 11/27/2015 16:29'!
testInTransitions3
	| process transition task1 gateway |

	process := self getReportToArchitectWorkflow.

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getEndNodeNamed: 'end' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 11/27/2015 16:26'!
testLoop

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'test-case' ifNone: [self assert: false]) loopType = 'Standard').

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'test-case' ifNone: [self assert: false]) loopCondition = 
			'[:form | form approved = ''false'']').

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'test-case' ifNone: [self assert: false]) getStartQuantity == nil).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'test-case' ifNone: [self assert: false]) getCompletionQuantity = 5).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'execute-test' ifNone: [self assert: false]) loopType = 'MultiInstance').

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'execute-test' ifNone: [self assert: false]) loopCondition == nil).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'execute-test' ifNone: [self assert: false]) getStartQuantity == 2).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'execute-test' ifNone: [self assert: false]) getCompletionQuantity = 10).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) loopType = 'MultiInstance').

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) loopCondition = 
			'[:form | form numberOfLoops]').

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) getStartQuantity == nil).

	self assert: 
		((self getTestCaseWorkflow getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false]) getCompletionQuantity = 9).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 lanes' stamp: 'BrunoBB 11/27/2015 16:27'!
testObjectsInLanes
	| pool workflow lane1 lane2 lane3 |

	pool := self getTestCasePool.
	workflow := self getTestCaseWorkflow.

	lane1 := pool getLaneNamed: 'developer' ifNone: [self assert: false].
	lane2 := pool getLaneNamed: 'test-expert' ifNone: [self assert: false].
	lane3 := pool getLaneNamed: 'tester' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'fix-issue' ifNone: [self assert: false]) == (workflow getSubprocessNamed: 'fix-issue' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == workflow startNode).

	self assert: ((lane2 getAnyObjectNamed: 'analyze-issue-report' ifNone: [self assert: false]) == (workflow getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'accept-issue' ifNone: [self assert: false]) == (workflow getGatewayNamed: 'accept-issue' ifNone: [self assert: false])).

	self assert: ((lane2 getAnyObjectNamed: 'end' ifNone: [self assert: false]) == (workflow getEndNodeNamed: 'end' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'execute-test' ifNone: [self assert: false]) == (workflow getTaskNamed: 'execute-test' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'is-issue' ifNone: [self assert: false]) == (workflow getGatewayNamed: 'is-issue' ifNone: [self assert: false])).

	self assert: ((lane3 getAnyObjectNamed: 'test-ok' ifNone: [self assert: false]) == (workflow getTaskNamed: 'test-ok' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 lanes' stamp: 'BrunoBB 11/27/2015 16:28'!
testObjectsInLanes2
	| pool workflow lane1 |

	pool := self getFixIssuePool.
	workflow := self getFixIssueWorkflow.

	lane1 := pool getLaneNamed: 'developer' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == workflow startNode).

	self assert: ((lane1 getAnyObjectNamed: 'analyze-issue' ifNone: [self assert: false]) == (workflow getTaskNamed: 'analyze-issue' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'can fix' ifNone: [self assert: false]) == (workflow getGatewayNamed: 'can fix' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-fixes' ifNone: [self assert: false]) == (workflow getTaskNamed: 'report-fixes' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'internal-test' ifNone: [self assert: false]) == (workflow getTaskNamed: 'internal-test' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-to-architect' ifNone: [self assert: false]) == (workflow getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 lanes' stamp: 'BrunoBB 11/27/2015 16:30'!
testObjectsInLanes3
	| pool workflow lane1 |

	pool := self getReportToArchitectPool.
	workflow := self getReportToArchitectWorkflow.

	lane1 := pool getLaneNamed: 'architect' ifNone: [self assert: false].

	self assert: ((lane1 getAnyObjectNamed: 'start' ifNone: [self assert: false]) == workflow startNode).

	self assert: ((lane1 getAnyObjectNamed: 'analyze-developer-report' ifNone: [self assert: false]) == (workflow getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'has-solution' ifNone: [self assert: false]) == (workflow getGatewayNamed: 'has-solution' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-workaround' ifNone: [self assert: false]) == (workflow getTaskNamed: 'report-workaround' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'report-solution' ifNone: [self assert: false]) == (workflow getTaskNamed: 'report-solution' ifNone: [self assert: false])).

	self assert: ((lane1 getAnyObjectNamed: 'end' ifNone: [self assert: false]) == (workflow getEndNodeNamed: 'end' ifNone: [self assert: false])).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 inout transitions' stamp: 'BrunoBB 11/27/2015 16:27'!
testOutTransitions
	| process transition task1 gateway |

	process := self getTestCaseWorkflow.
	transition := process getTransitionNamed: 'start-case' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'test-case' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'run-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'execute-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-issue' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-ok' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'is-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'report-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-report' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'reject-issue' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'accept-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'fix' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'test-again' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 inout transitions' stamp: 'BrunoBB 11/27/2015 16:28'!
testOutTransitions2
	| process transition task1 gateway |

	process := self getFixIssueWorkflow.
	transition := process getTransitionNamed: 'start-analyze' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-issue' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-fix' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'can fix' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'no-fix-report' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	task1 := process getTaskNamed: 'report-fixes' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'do-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'architect-done' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'internal-test' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'finish-internal-test' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test proc 3 inout transitions' stamp: 'BrunoBB 11/27/2015 16:29'!
testOutTransitions3
	| process transition task1 gateway |

	process := self getReportToArchitectWorkflow.
	transition := process getTransitionNamed: 'start-dev-analysis' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'analyze-developer-report' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'evaluate-a-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-workaround' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'has-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'create-solution' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'report-workaround' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-workaround' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'report-solution' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'end-solution' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !

!XPDLReader2Test2 methodsFor: 'test subprocess' stamp: 'BrunoBB 11/27/2015 16:30'!
testSubProcessesConnection

	self assert: (
		(self getTestCasePool) getSubProcessNodes asArray last subProcess == self getFixIssuePool).

	self assert: (
		(self getFixIssuePool) getSubProcessNodes asArray last subProcess == self getReportToArchitectPool).! !

!XPDLReader2Test2 methodsFor: 'test proc 1 activities' stamp: 'BrunoBB 11/27/2015 16:26'!
testSubProcessNames
	| subprocessesNames |

	subprocessesNames := #('fix-issue').

	self assert: (self getTestCaseWorkflow getSubProcessNodes allSatisfy: [:each | subprocessesNames includes: each getName]).

	self assert: (self getTestCaseWorkflow getSubProcessNodes size = subprocessesNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 activities' stamp: 'BrunoBB 11/27/2015 16:25'!
testSubProcessNames2
	| subprocessesNames |

	subprocessesNames := #('report-to-architect').

	self assert: (self getFixIssueWorkflow getSubProcessNodes allSatisfy: [:each | subprocessesNames includes: each getName]).

	self assert: (self getFixIssueWorkflow getSubProcessNodes size = subprocessesNames size).! !

!XPDLReader2Test2 methodsFor: 'test proc 2 conditions' stamp: 'BrunoBB 11/27/2015 16:28'!
testTransitionCreateReportConditions
	| process transition |

	process := self getFixIssueWorkflow.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-fixes' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form developerCanFix = ''yes'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 3 conditions' stamp: 'BrunoBB 11/27/2015 16:29'!
testTransitionCreateSolutionConditions
	| process transition |

	process := self getReportToArchitectWorkflow.

	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-solution' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form hasSolution = ''yes'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 3 conditions' stamp: 'BrunoBB 11/27/2015 16:29'!
testTransitionCreateWorkaroundConditions
	| process transition |

	process := self getReportToArchitectWorkflow.

	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'report-workaround' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form hasSolution = ''no'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 11/27/2015 16:26'!
testTransitionFixIssueConditions
	| process transition |

	process := self getTestCaseWorkflow.
	transition := process transitions detect: [:each | each endNode == (process getSubprocessNamed: 'fix-issue' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form acceptOrReject = ''accept'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 2 conditions' stamp: 'BrunoBB 11/27/2015 16:28'!
testTransitionNoFixReportConditions
	| process transition |

	process := self getFixIssueWorkflow.
	transition := process transitions detect: [:each | each endNode == (process getSubprocessNamed: 'report-to-architect' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form developerCanFix = ''no'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 11/27/2015 16:26'!
testTransitionRejectIssueConditions
	| process transition |

	process := self getTestCaseWorkflow.
	transition := process transitions detect: [:each | (each endNode == (process getEndNodeNamed: 'end' ifNone: [self assert: false]))
		and: [each startNode isGatewayNode]
	].

	self assert: (transition startCondition = '[:form | form acceptOrReject = ''reject'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 11/27/2015 16:27'!
testTransitionReportIssueConditions
	| process transition |

	process := self getTestCaseWorkflow.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'analyze-issue-report' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form result = ''failed'']')! !

!XPDLReader2Test2 methodsFor: 'test proc 1 conditions' stamp: 'BrunoBB 11/27/2015 16:27'!
testTransitionTestOkConditions
	| process transition |

	process := self getTestCaseWorkflow.
	transition := process transitions detect: [:each | each endNode == (process getTaskNamed: 'test-ok' ifNone: [self assert: false])].

	self assert: (transition startCondition = '[:form | form result ~= ''failed'']')! !

TestCase subclass: #XPDLReader2Test3
	instanceVariableNames: 'reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2_Tests'!

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:30'!
getProcess1Pool

	^(reader getPackageNamed: 'Diagram 1') getPoolNamed: 'Process 1' ifNone: [self assert: false]! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:30'!
getProcess1Workflow

	^(reader getPackageNamed: 'Diagram 1') getWorkflowNamed: 'Process 1' ifNone: [self assert: false]! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:30'!
getProcess2Pool

	^(reader getPackageNamed: 'Diagram 1') getPoolNamed: 'Process 2' ifNone: [self assert: false]! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 10/31/2015 15:31'!
getProcess2Workflow

	^(reader getPackageNamed: 'Diagram 1') getWorkflowNamed: 'Process 2' ifNone: [self assert: false]! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 13:19'!
setUp

	reader := (XPDLReader2 for: 'MultiplePools' withString: XPDLProcessTemplate xpdlExample_MultiplePools)
				yourself! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:33'!
testActivitiesNames
	| taskNames |

	taskNames := #('Task 1' 'Task 2' 'Task 3' 'Task 4' 'Task 5' 'Task 6').

	self assert: (self getProcess1Workflow getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getProcess1Workflow getTaskNodes size = taskNames size).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:33'!
testActivitiesNames2
	| taskNames |

	taskNames := #('Task 7' 'Task 8' 'Task 9').

	self assert: (self getProcess2Workflow getTaskNodes allSatisfy: [:each | taskNames includes: each getName]).

	self assert: (self getProcess2Workflow getTaskNodes size = taskNames size).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:33'!
testGatewaysNames
	| gatewaysNames |

	gatewaysNames := #('important' 'define').

	self assert: (self getProcess1Workflow getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getProcess1Workflow getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:33'!
testGatewaysNames2
	| gatewaysNames |

	gatewaysNames := #('do it').

	self assert: (self getProcess2Workflow getGatewayNodes allSatisfy: [:each | gatewaysNames includes: each getName]).

	self assert: (self getProcess2Workflow getGatewayNodes size = gatewaysNames size).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:34'!
testInTransitions
	| process transition task1 gateway |

	process := self getProcess1Workflow.

	task1 := process getTaskNamed: 'Task 1' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr1' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 2' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr2' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'important' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr3' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 4' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr4' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end 1' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr5' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'Task 5' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr6' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 3' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr7' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getEndNodeNamed: 'end 1' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr8' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 6' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr9' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'define' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr10' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 3' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr11' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end 2' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr12' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:34'!
testInTransitions2
	| process transition task1 gateway |

	process := self getProcess2Workflow.

	task1 := process getTaskNamed: 'Task 7' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr1' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	gateway := process getGatewayNamed: 'do it' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr2' ifNone: [self assert: false].
	self assert: (gateway inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end 1' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr3' ifNone: [self assert: false].
	self assert: (task1 inTransitions first == transition).

	task1 := process getTaskNamed: 'Task 8' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr4' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getTaskNamed: 'Task 9' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr5' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).

	task1 := process getEndNodeNamed: 'end 2' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr6' ifNone: [self assert: false].
	self assert: (task1 inTransitions last == transition).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:34'!
testOutTransitions
	| process transition task1 gateway |

	process := self getProcess1Workflow.
	transition := process getTransitionNamed: 'tr1' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 1' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr2' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 2' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr3' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'important' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr4' ifNone: [self assert: false].
	self assert: (gateway outTransitions second == transition).

	gateway := process getGatewayNamed: 'important' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr6' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'important' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr7' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'Task 4' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr5' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 3' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr8' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 5' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr9' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 6' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr10' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'define' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr11' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	gateway := process getGatewayNamed: 'define' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr12' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).! !

!XPDLReader2Test3 methodsFor: 'other' stamp: 'BrunoBB 11/27/2015 16:34'!
testOutTransitions2
	| process transition task1 gateway |

	process := self getProcess2Workflow.
	transition := process getTransitionNamed: 'tr1' ifNone: [self assert: false].
	self assert: (process startNode outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 7' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr2' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	gateway := process getGatewayNamed: 'do it' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr3' ifNone: [self assert: false].
	self assert: (gateway outTransitions last == transition).

	gateway := process getGatewayNamed: 'do it' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr4' ifNone: [self assert: false].
	self assert: (gateway outTransitions first == transition).

	task1 := process getTaskNamed: 'Task 8' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr5' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).

	task1 := process getTaskNamed: 'Task 9' ifNone: [self assert: false].
	transition := process getTransitionNamed: 'tr6' ifNone: [self assert: false].
	self assert: (task1 outTransitions last == transition).! !
